aboutsummaryrefslogtreecommitdiff
path: root/gen
diff options
context:
space:
mode:
authorThomas Voss <mail@thomasvoss.com> 2024-04-09 20:37:09 +0200
committerThomas Voss <mail@thomasvoss.com> 2024-04-09 20:37:09 +0200
commita83a4de7820cf0a7c470c3a8acbfebf1a93b215f (patch)
treeda661591e39133eb546d9d483852193f5a0c8719 /gen
parentc02c6641704245b35be78f45e2291a3cb93a6511 (diff)
Add uprop_get_bpb() and uprop_get_bpt()
Diffstat (limited to 'gen')
-rwxr-xr-xgen/data-files1
-rwxr-xr-xgen/prop/bpb52
-rwxr-xr-xgen/prop/bpt53
3 files changed, 106 insertions, 0 deletions
diff --git a/gen/data-files b/gen/data-files
index a2c64d6..0946f7e 100755
--- a/gen/data-files
+++ b/gen/data-files
@@ -8,6 +8,7 @@ readonly BASE=https://www.unicode.org/Public/UCD/latest/ucd
readonly URLS='
auxiliary/GraphemeBreakProperty.txt
+BidiBrackets.txt
DerivedCoreProperties.txt
DerivedNormalizationProps.txt
emoji/emoji-data.txt
diff --git a/gen/prop/bpb b/gen/prop/bpb
new file mode 100755
index 0000000..52e3a9d
--- /dev/null
+++ b/gen/prop/bpb
@@ -0,0 +1,52 @@
+#!/bin/sh
+
+set -e
+cd "${0%/*}/../.."
+exec >lib/unicode/prop/uprop_get_bpb.c
+
+gawk '
+BEGIN {
+ FS = " *(; *|#.*)"
+
+ print "/* This file is autogenerated by gen/prop/bpb; DO NOT EDIT. */"
+ print ""
+ print "#include \"__bsearch.h\""
+ print "#include \"macros.h\""
+ print "#include \"rune.h\""
+ print "#include \"unicode/prop.h\""
+ print ""
+}
+
+/^[^#]/ {
+ props[strtonum("0X" $1)] = strtonum("0X" $2)
+}
+
+END {
+ print "static constexpr rune lookup_lat1[] = {"
+ for (i = 0; i < 0x100; i++) {
+ if (i % 8 == 0)
+ printf "\t"
+ printf "0x%02X,%s", props[i] ? props[i] : 0, i % 8 == 7 ? "\n" : " "
+ }
+ print "};"
+ print ""
+ print "static const struct {"
+ print "\trune k, v;"
+ print "} lookup[] = {"
+
+ for (i = 0x100; i <= 0x10FFFF; i++) {
+ if (props[i])
+ printf "\t{RUNE_C(0x%06X), RUNE_C(0x%06X)},\n", i, props[i]
+ }
+
+ print "};"
+ print ""
+ print "__MLIB_DEFINE_BSEARCH_KV(rune, lookup, 0)"
+ print ""
+ print "rune"
+ print "uprop_get_bpb(rune ch)"
+ print "{"
+ print "\treturn ch < lengthof(lookup_lat1) ? lookup_lat1[ch] : mlib_lookup_kv(ch);"
+ print "}"
+}
+' data/BidiBrackets.txt
diff --git a/gen/prop/bpt b/gen/prop/bpt
new file mode 100755
index 0000000..b73b804
--- /dev/null
+++ b/gen/prop/bpt
@@ -0,0 +1,53 @@
+#!/bin/sh
+
+set -e
+cd "${0%/*}/../.."
+exec >lib/unicode/prop/uprop_get_bpt.c
+
+gawk '
+BEGIN {
+ FS = " *(; *|#.*)"
+
+ print "/* This file is autogenerated by gen/prop/bpt; DO NOT EDIT. */"
+ print ""
+ print "#include \"__bsearch.h\""
+ print "#include \"macros.h\""
+ print "#include \"rune.h\""
+ print "#include \"unicode/prop.h\""
+ print ""
+}
+
+/^[^#]/ {
+ props[strtonum("0X" $1)] = "BPT_" toupper($3)
+}
+
+END {
+ print "static constexpr enum uprop_bpt lookup_lat1[] = {"
+ for (i = 0; i < 0x100; i++) {
+ if (i % 8 == 0)
+ printf "\t"
+ printf "%5s,%s", props[i] ? props[i] : "BPT_N", i % 8 == 7 ? "\n" : " "
+ }
+ print "};"
+ print ""
+ print "static const struct {"
+ print "\trune k;"
+ print "\tenum uprop_bpt v;"
+ print "} lookup[] = {"
+
+ for (i = 0x100; i <= 0x10FFFF; i++) {
+ if (props[i])
+ printf "\t{RUNE_C(0x%06X), %s},\n", i, props[i]
+ }
+
+ print "};"
+ print ""
+ print "__MLIB_DEFINE_BSEARCH_KV(enum uprop_bpt, lookup, BPT_N)"
+ print ""
+ print "enum uprop_bpt"
+ print "uprop_get_bpt(rune ch)"
+ print "{"
+ print "\treturn ch < lengthof(lookup_lat1) ? lookup_lat1[ch] : mlib_lookup_kv(ch);"
+ print "}"
+}
+' data/BidiBrackets.txt